$debug
c	Programme de calcul des cartes d'ecoulement
c     par la methode de Taitel et Dukler
c	Traduit du HP41
c	
c  Dclarations de types et organisatlon memoire
c	HoriTD03.for fils de HoriTD02.for
v	Version double prcision
c	E/S adaptes au trac
c
c
	implicit real*8 (a-h,o-z)
	integer*4 system
	external chregm, TA, TD, TAC, TC
	logical turbl,turbg,chregm
c
	character *40 parnm1(6),titre1,parnm2(6),titre2
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si,ag,al,ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg
c
	dimension par1(6), par2(6)
	equivalence (sg,th)
c
c
	data titre1/'CARTE D''ECOULEMENT DE TAITEL ET DUKLER'/
      data parnm1/'MASSE VOLUMIQUE OU GAZ en kg/m3',
	&            'MASSE VOLUMIQUE OU LIQ. en kg/m3',
	&            'VISCOSITE DYNAMIQUE DU GAZ en Pa s',
	&            'VISCOSITE DYNAMIQUE DU LIQ. en Pa s',
	&            'DIAMETRE OU TUBE en mm',
	&            'PENTE (positive en ec.descend.) en deg'/
c
	data par1/1.20d0,1000d0,18.12d-6,1.d-3,50.d0,0d0/
c
	data titre2/'PARAMETRES DE LA CARTE '/
	data parnm2/'VIT. superficielle GAZ. MINI en m/s',
     &            'VIT. superficielle GAZ MAXI en m/s',
     &            'VIT. superficielle LIQ. MINI en m/s',
     &            'VIT. superficielle LIQ. MAXI en m/s',
     &            'Nombre de points par decade (GAZ) ',
     &            'Nombre de points par decade (LIQ) '/
c
      data par2/.005d0,500d0,.005d0,50d0,25d0,25d0/
c
      pi=4.d0*datan(1.d0)
c
	open(6,file='HoriTD03.out')
	open(7,file='HoriTD03.plp')
c
c  introduction des parametres du probleme
c
c	call lire(titre1,6,parnm1,par1,'1pe12.3')

c  affectation des parametres

	rg=par1(1)
	rl=par1(2)
	amug=par1(3)
	amul=par1(4)
	anug = amug/rg
	anul = amul/rl
	diam=par1(5)/1000d0
	alp=pi/180d0*par1(6)
c
c
c	
c	parametres descriptifs de la carte
c
c
c	call lire(titre2,6,parnm2,par2,'f12.5')
c
c	affectation des parametres
c	
      ajgmin=par2(1)
	ajgmax=par2(2)
	ajlmin=par2(3)
	ajlmax=par2(4)
	djg=10.d0**(1.d0/par2(5))
	djl=10.d0**(1.d0/par2(6))
c
	write(7,'('' set xrange['',1pE10.3,'':'',1pE10.3,'']'')')
	&         ajgmin,ajgmax
	write(7,'('' set yrange['',1pE10.3,'':'',1pE10.3,'']'')')
	&         ajlmin,ajlmax

c
c	initialisation des constantes
c
	g=9.81d0
	y=(rl-rg)*g*dsin(alp)
	z=(rl-rg)*g*diam*dcos(alp)
	cl=0.046d0
	cg=0.046d0
	an=0.2d0
	am=0.2d0
	turbl=.true.
	turbg=.true.
c
c	calcul du pojnt triple AB
c
1	continue
	th=pi/2.d0
	call geom
	call aa
	call bb
	call cc
	fr2=1.d0/c
	call fr2jg
	aJgAB=ajg
	call jgxg
	call xgxl1
	call xljl
	aJlAB=ajl
	if(chregm()) goto 1 
	write(*,'(/'' Point triple AB'')')
	call sort
	write(6,'(1p2e14.6)')aJGAB,aJLAB
c
c
c	Transition B, 
c	intermittent - annulaire
c	pour JG>JGAB
c
	aJg = djg**(int(dlog10(aJgAB)/dlog10(djg)+1))
	write(*,'(/'' Transition B'')')
c
2	continue
	call jgxg
	call xgxl1
	call xljl
	if(chregm()) goto 2 
	call sort
	write(6,'(1p2e14.6)')aJG,aJL
	if(aJG.lt.aJGmin.or.aJg.gt.aJgmax
	& .or.aJg.le.aJlmin.or.aJl.ge.aJlmax)goto 3
	aJg = aJg*djg
	goto 2

c
c
c	Transition A,
c	JG < JGAB
c
c
3	continue
	write(6,'(/)')
	write(6,'(1p2e14.6)')aJGAB,aJLAB
	aJg = djg**(int(dlog10(aJgAB)/dlog10(djg)))
	write(*,'(/'' Transition A'')')

	th = pi/2d0
4	continue
	call jgfr2
	th = SV(TA,0.01d0,pi-.01d0,1.d-6)
	call aa
	call bb
	call jgxg
	call xgxl1
	call xljl
	if(chregm()) goto 4 
	call sort
	write(6,'(1p2e14.6)')aJG,aJL
c	read(*,*)
	if(aJG.lt.aJGmin.or.aJg.gt.aJgmax
	& .or.aJl.le.aJlmin.or.aJl.ge.aJlmax)goto 5
	aJg = aJg/dJg
	goto 4
c
c
c	JG > JGAB
c
c
5	continue

	write(6,'(/)')
	write(6,'(1p2e14.6)')aJGAB,aJLAB
	aJg = djg**(int(dlog10(aJgAB)/dlog10(djg)+1))
	write(*,*)

	th = pi/2d0
6	continue
	call jgfr2
	th = SV(TA,0.01d0,pi-0.01d0,1.d-6)
	call aa
	call bb
	call jgxg
	call xgxl1
	call xljl
	if(chregm()) goto 6 
	call sort
	write(6,'(1p2e14.6)')aJG,aJL
c	read(*,*)
	if(aJG.lt.aJGmin.or.aJg.gt.aJgmax
	& .or.aJl.le.aJlmin.or.aJl.ge.aJlmax)goto 7
	aJg = aJg*dJg
	goto 6
c
c
c	calcul du point triple BD
c
7	continue
	th = pi/2d0
8	continue
	call geom
	call dd
	xl=d*z/diam
	call xljl
	aJLDB = aJL
	call aa
	call bb
	call xlxg1
	call xgjg
	aJGDB= aJG
	if(chregm())goto 8 
	write(*,'(/'' Point triple BD'')')
	call sort
c
c
c	Transition D
c
	write(*,'(/'' Transition D'')')
	aJg = djg**(int(dlog10(aJgDB)/dlog10(djg)))
	write(6,'(/)')
	write(6,'(1p2e14.6)')aJGDB,aJLDB
	th = pi/2d0
9	continue
	call jgxg
	th = SV(TD,.01d0,pi-.01d0,1.d-6)	
	call xljl
	if(chregm())goto 9
	call sort 
	write(6,'(1p2e14.6)')aJG,aJL
	if(aJG.lt.aJGmin.or.aJg.gt.aJgmax
	& .or.aJl.le.aJlmin.or.aJl.ge.aJlmax)goto 10
	aJg = aJg/dJg
	goto 9
c
c
c	calcul du point triple AC
c
c
10	continue
c	do x=.01,3.1,.01
c	write(6,*)x,TAC(x)
c	enddo
c	stop
	th = SV(TAC,.01d0,pi-.01d0,1.d-6)
c	write(*,*)th
c	read(*,*)
	if(chregm())goto 10  
	aJLAC = aJL
	aJGAC = aJG
      write(*,'(/'' Point triple AC'')')
	call sort
	write(6,'(/)')
	write(6,'(1p2e14.6)')aJGAC,aJLAC
c
c
c	Transition C
c
	write(*,'(/'' Transition C'')')
	aJl = djl**(inthl(dlog10(aJlAC)/dlog10(djl)))
c	write(*,*)aJl
c
11	continue
	call jlrel
	call jlxl
	th = SV(TC,.01d0,pi-.01d0,1.d-6)	
	if(chregm())goto 11
	call sort 
	write(6,'(1p2e14.6)')aJG,aJL
	if(aJG.lt.aJGmin.or.aJg.gt.aJgmax
	& .or.aJl.le.aJlmin.or.aJl.ge.aJlmax)goto 12
	aJL = aJL/dJL
	goto 11
		
12	continue
c
c	Launches Gnuplot
c
	close(6);close(7)
	Ier=System('P:\Gnuplot\bin\wgnuplot.exe HoriTD03.plt')
c	Ier=System('wgnuplot.exe HoriTD03.plt')
	if(Ier.ne.0)
	&write(*,'('' Gnuplot script launch was not successful :'',i3)')Ier



	end
c
c
	subroutine geom 
c 
c
c	Calcul des lments gomtriques (eq.11) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	pis4=pi/4.d0
	cost=dcos(th)
	sint=dsin(th) 
	sl=pi-th 
	si=sint
	ag=.25d0*(th-sint*cost)
	al=pis4-ag
	ul=pis4/al
	ug=pis4/ag 
	dl=4.d0*al/sl
	dg=4.d0*ag/(si+sg)
	end


	subroutine aa 
c 
c
c	Calcul du coefficient a (eq.12) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	a=(ul*dl)**(-an)*ul*ul*sl/al
	end


	subroutine bb 
c 
c
c	Calcul du coefficient b (eq.13) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	b=(ug*dg)**(-am)*ug*ug*(sg/ag+si/ag+si/al)
	end


	subroutine cc 
c 
c
c	Calcul du coefficient c (eq.14) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	c2=(1.d0-cost)*.5d0
	dalsdhl = sint 
	c=ug*ug/c2/c2*dalsdhl/ag
c
c	write(*,*)ug,c2,dalsdhl,ag,cost,sint	
c
	end


	subroutine dd 
c 
c
c	Calcul du coefficient d (eq.15) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	d=8.d0*ag/si/ul/ul*(ul*dl)**an
	end


	subroutine ee 
c 
c
c	Calcul du coefficient e (eq.16) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
	data s/0.01d0/
c
c
	e=4.d0/ul/ug/ug/s
	end



	subroutine fr2jg 
c 
c
c	Calcul de jg connaissant fr2 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	x=fr2*z/rg
	ajg=dsqrt(x)
	end



	subroutine jgfr2 
c 
c
c	Calcul de fr2 connaissant jG 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	fr2=rg*ajg**2/z
	end

	subroutine jgxg 
c 
c
c	Calcul de xg connaissant jg 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	xg=4.d0*cg/diam*(ajg*diam/anug)**(-am)*rg*ajg*ajg/2.d0
	end

	subroutine xgjg 
c 
c
c	Calcul de jg connaissant xg 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	x=xg*diam/2.d0/cg/rg*(diam/anug)**am
	aJg=x**(1.d0/(2.d0-am))
	end


	subroutine xgxl1 
c 
c
c	Calcul de xl connaissant xg (eq. 1) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	xl=(b*xg+4.d0*y)/a
	end


	subroutine xlxg1 
c 
c
c	Calcul de xg connaissant xl (eq. 1) 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	xg=(a*xl-4.d0*y)/b
	end


	subroutine xljl
c 
c
c	Calcul de jl connaissant xl  
c 
c
	implicit real*8 (a-h,o-z)
      logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c	Modif HL pour permettre le contre courant pendant la dichothomie
c
	x=xl*diam/2.d0/cl/rl*(diam/anul)**an
	if(x.gt.0)then
	ajl = x**(1.d0/(2.d0-an))
	else
	ajl = -(-x)**(1.d0/(2.d0-an))
	endif
	end


	subroutine jlxl
c 
c
c	Calcul de xl connaissant jl  
c 
c
	implicit real*8 (a-h,o-z)
      logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	call jlrel
	xl=rel**(-an)*cl*2.d0/diam*rl*aJl**2
	end


	subroutine jlrel
c 
c
c	Calcul de Rel connaissant jl  
c 
c
	implicit real*8 (a-h,o-z)
      logical turbl,turbg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	Rel = dabs(ajL)*diam/anul 
	end



	function chregm
c 
c
c	test du changement de regime d'ecoulement
c		chregm=.false. le calcul courant est bon
c		chregm=.true.  les valeurs calculees de jg et jl
c					   contredisent les hypotheses sur les
c					   regimes d'ecoulement supposes
c			           cl,cg,an,am mis  jour en fonction des
c					   nouvelles previsions
c
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg,turbl1,turbg1,chregl,chregg,chregm
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	xrel=dabs(ajl)*ul*diam*dl/anul
	xreg=ajg*ug*diam*dg/anug
c
	turbl1=xrel.gt.1502.d0
	turbg1=xreg.gt.1502.d0
c
	chregl=(turbl.and..not.turbl1).or.(.not.turbl.and.turbl1)
	chregg=(turbg.and..not.turbg1).or.(.not.turbg.and.turbg1)
	chregm=chregl.or.chregg
c
	if(chregl) then
	  if(turbl1) then 
		turbl=.true.
		cl=0.046d0
		an=.2d0
	  else
	    turbl=.false.
		cl=16.d0
		an=1.d0
	  endif
	endif
c
c
	if(chregg) then
	  if(turbg1) then 
		turbg=.true.
		cg=0.046d0
		am=.2d0
	  else
	    turbg=.false.
		cg=16.d0
		am=1.d0
	  endif
	endif
c

	end



	subroutine sort
c 
c
c	affichage d'dun point de la carte  
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
	character crl, crg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c

	if(turbl)then
	crl='T'
	else
	crl='L'
	endif
c
	if(turbg)then
	crg='T'
	else
	crg='L'
	endif
c
	write(*,'(1X,2A1,'' JG='',1pe10.2,'' JL='' ,e10.2)')
	&		crg,crl,ajg,ajl
c
	end

	real*8 function SV(func,a0,b0,eps)
c
c	Rsolution de Func(x)=0 par dichotomie
c
	implicit real*8 (a-h,o-z)
	a= a0
	b = b0
	fa = func(a)
	fb = func(b)
c	write(*,*)fa,fb
c
1	continue		
c	write(*,*)a,b
	x1 = (a+b)/2.d0
	fx1 = func(x1)
	if(fx1*fa.gt.0)then
	a = x1
	fa = fx1
	else
	b = x1
	fb = fx1
	endif
c	read(*,*)
	if(dabs(b-a).gt.eps)goto 1

c
	SV=x1
	end

	real*8 Function TA(x) 
c
c	Fonction TA  annuler pour la transition A 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
	character crl, crg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	th = x
	call geom	
	call cc
	TA=fr2*c-1.d0
c	write(*,*)'TA',TA
c
	end

	real*8 Function TD(x) 
c
c	Fonction TD  annuler pour la transition D 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
	character crl, crg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	th = x
	call geom	
	call aa
	call bb
	call xgxl1
	call dd
	TD = xl/z*diam-d
c	write(*,*)'TD',TD
c
	end


	real*8 Function TAC(x) 
c
c	Fonction TAC  annuler pour le pt triple AC 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
	character crl, crg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	th = x
	call geom	
	call cc
	fr2 = 1.d0/c
	call fr2jg
	call jgxg
	call bb
	call aa
	call xgxl1
	call xljl
	call jlrel
	call ee
	TAC = Rel*fr2-e

c	write(*,*)'TAC',TAC
c
	end

	real*8 Function TC(x) 
c
c	Fonction TC  annuler pour la transition C 
c 
c
	implicit real*8 (a-h,o-z)
	logical turbl,turbg
	character crl, crg
c
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si, ag, al, ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg

c
	equivalence (sg,th)
c
c
	th = x
	call geom	
	call ee
	fr2=e/rel
	call fr2jg
	call jgxg
	call bb
	call aa
	TC = (a*xl-b*xg-4.d0*y)/(xl+xg)

c	write(*,*)'TC',TC
c
	end


	integer*4 function inthl(x)
	implicit real*8 (a-h,o-z)
	inthl=int(x)
	if(x.lt.0d0) inthl=inthl-1
	end


	subroutine lire(titre,n,parname,par,form)
c
c
c		menu de lecture et changement des parametres
c
c
c	titre..........chaine de caracteres titre du menu (40 car)
c	n..............nombre de parametres
c	parname........character*40 a n elements
c	par............tableau reel*4 a n elements au moins
c	               servant au passage des parametres
c	form...........caracter*5 donnant le format d'ecriture des
c	               nombres
c
c
c
	implicit real*8 (a-h,o-z)
	character*(*) form
	character*31 ffor
	character*40 titre,parname(n)
	character*1 esc
	dimension par(n)
	esc=char(27)
c
c
c		calcule le format d'ecriture du tableau
c
c
	write(ffor,100)form
c100	format(23h(i3,' ---> ',a40,' : ',,a5,1h))
100	format(23h(i3,' ---> ',a40,' : ',,a7,1h))
c
c
c	efface l'ecran et affiche le titre en dble largeur
c
c
c	write(*,'(1x,a1,''[2J''\)')esc
	write(*,'(1x,t20,a40/)')titre
c
c	ecrit les variables et leurs valeurs,puis le message
c	d'interrogation et efface la reponse precedente
c
50	write(*,ffor)(i,parname(i),par(i),i=1,n)
	write(*,'(//'' Entrer le numero du parametre,nouvelle valeur'')')
c	write(*,'('' taper 0,0 pour sortir du menu''/
c     *            '' taper -1,0 pour arreter  --->'',a1,''[K''\)')esc
	write(*,'('' taper 0,0 pour sortir du menu''/
     *            '' taper -1,0 pour arreter  --->''\)')
c
c	lecture de l'indice et de la valeur
c
   	read(*,*,err=200,end=300)i,val
	if(i.gt.0..and.i.le.n) par(i)=val
c
c	test de sortie
c
	
400	continue
	if(i.eq.0) then
c	write(*,'('' Retour au programme appelant'')')
	return
	endif
	if(i.lt.0)stop'Retour DOS' 
c
c	retourne en haut de l'ecran
c	descend de deux lignes et va en bout de ligne precedente (<-)
c	pour se retrouver au debut de la liste des variables
c
c	write(*,'(1x,a1,''[2;1f'')')esc
	goto 50
c
c	erreur de lecture on sort du menu
c
200	i=0
	goto 400
c
c	fin de fichier on sort du programme retour dos
c
300	i=-1
	goto 400
	end
